/*
 *   Copyright 2003-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */
#ifndef IMESSAGEDATA_INCLUDED
#define IMESSAGEDATA_INCLUDED


/*
 *   @class IMessageData
 *   @brief interface for the IMessageData class.
 */
/* Allow AxisAdminService access to the private methods */
AXISC_STORAGE_CLASS_INFO void axiscDestroyIMessageData(AXISCHANDLE messageData);
AXISC_STORAGE_CLASS_INFO int axiscSetProperty(AXISCHANDLE messageData, AxiscChar * pachName, 
	const void * pachValue, int len);
AXISC_STORAGE_CLASS_INFO void axiscSetComplexProperty(AXISCHANDLE messageData, AxiscChar * pachName, 
	void * pachValue, int iObjectSize);
AXISC_STORAGE_CLASS_INFO const void * axiscGetProperty(AXISCHANDLE messageData, AxiscChar * sName);
AXISC_STORAGE_CLASS_INFO void * axiscGetComplexProperty(AXISCHANDLE messageData, AxiscChar * pachName);
AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetOperationName(AXISCHANDLE messageData);
AXISC_STORAGE_CLASS_INFO void axiscGetSoapSerializer(AXISCHANDLE messageData, AXISCHANDLE pIWSS);
AXISC_STORAGE_CLASS_INFO void axiscGetSoapDeSerializer(AXISCHANDLE messageData, AXISCHANDLE pIWSDS);
AXISC_STORAGE_CLASS_INFO void axiscGetSoapSerializer(AXISCHANDLE messageData, AXISC_IHandlerSoapSerializer * * pIHandlerSoapSerializer);
AXISC_STORAGE_CLASS_INFO void axiscGetSoapDeSerializer(AXISCHANDLE messageData, AXISC_IHandlerSoapDeSerializer * * pIHandlerSoapDeSerializer);
AXISC_STORAGE_CLASS_INFO void axiscSetUserName(AXISCHANDLE messageData, char*  m_sUserName);
AXISC_STORAGE_CLASS_INFO char*  axiscGetUserName(AXISCHANDLE messageData);
AXISC_STORAGE_CLASS_INFO AxiscBool axiscIsPastPivot(AXISCHANDLE messageData);
AXISC_STORAGE_CLASS_INFO int axiscSetPastPivotState(AXISCHANDLE messageData, AxiscBool bState);


#endif // IMESSAGEDATA_INCLUDED
