/*
 *   Copyright 2003-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */
/**
 * @file Call.h
 *
 * This file Contains the Call class and equivalent C function tables
 * that all web service stubs generated by WSDL2Ws tool use to talk
 * to Axis Engine.
 *
 */
/*
 * Revision 1.1  2004/05/24 samisa
 * Added accesser to transport 
 */
/*
 * Revision 1.2  2004/05/25 samisa
 * Added accesser to SOAP serializer 
 */
/*
 * Revision 1.3  2004/05/31 samisa
 * Added setProxy
 */
/* Call.h: interface for the Call class.*/
#ifndef CALL_INCLUDED
#define CALL_INCLUDED


AXISC_STORAGE_CLASS_INFO void axiscSetSOAPVersionCallBase(AXISCHANDLE callBase, AXISC_SOAP_VERSION version);
AXISC_STORAGE_CLASS_INFO int axiscSetTransportPropertyCallBase(AXISCHANDLE callBase, AXISC_TRANSPORT_INFORMATION_TYPE type, 
	const char * value);
AXISC_STORAGE_CLASS_INFO int axiscSetHandlerPropertyCallBase(AXISCHANDLE callBase, AxiscChar * name, 
	void * value, int len);
AXISC_STORAGE_CLASS_INFO int axiscSetProtocolCallBase(AXISCHANDLE callBase, AXISC_PROTOCOL_TYPE protocol);
AXISC_STORAGE_CLASS_INFO int axiscInitializeCallBase(AXISCHANDLE callBase, AXISC_PROVIDERTYPE nStyle);
AXISC_STORAGE_CLASS_INFO int axiscInvokeCallBase(AXISCHANDLE callBase);
AXISC_STORAGE_CLASS_INFO int axiscUnInitializeCallBase(AXISCHANDLE callBase);

/* Method that set the remote method name */
AXISC_STORAGE_CLASS_INFO void axiscSetOperationCallBase(AXISCHANDLE callBase, const char * pchOperation, 
	const char * pchNamespace);
AXISC_STORAGE_CLASS_INFO int axiscSetEndpointURICallBase(AXISCHANDLE callBase, const char * pchEndpointURI);

/* Method for adding complex parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddCmplxParameterCallBase(AXISCHANDLE callBase, void * pObject, 
	void * pSZFunct, void * pDelFunct, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method for adding complex type array parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddCmplxArrayParameterCallBase(AXISCHANDLE callBase, Axisc_Array * pArray, 
	void * pSZFunct, void * pDelFunct, void * pSizeFunct, 
	const AxiscChar * pName, const AxiscChar * pNamespace);

/* Method for adding basic type array parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddBasicArrayParameterCallBase(AXISCHANDLE callBase, Axisc_Array * pArray, 
	AXISC_XSDTYPE nType, const char * pName);

/* Method for adding parameters of basic types */
AXISC_STORAGE_CLASS_INFO void axiscAddParameterCallBase(AXISCHANDLE callBase, void * pValue, 
	const char * pName, AXISC_XSDTYPE nType);

/* Methods used by stubs to get a deserialized value of an XML element
     * as basic types
     */
AXISC_STORAGE_CLASS_INFO int axiscGetElementAsIntCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__boolean axiscGetElementAsBooleanCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned int axiscGetElementAsUnsignedIntCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO short axiscGetElementAsShortCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned short axiscGetElementAsUnsignedShortCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO char axiscGetElementAsByteCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned char axiscGetElementAsUnsignedByteCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__long axiscGetElementAsLongCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO long axiscGetElementAsIntegerCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned long axiscGetElementAsUnsignedLongCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO float axiscGetElementAsFloatCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO double axiscGetElementAsDoubleCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO double axiscGetElementAsDecimalCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetElementAsStringCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetElementAsAnyURICallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetElementAsQNameCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__hexBinary axiscGetElementAsHexBinaryCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__base64Binary axiscGetElementAsBase64BinaryCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetElementAsDateTimeCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetElementAsDateCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetElementAsTimeCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO long axiscGetElementAsDurationCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Methods used by stubs to get a deserialized value of XML attribute
     * as basic types
     */
AXISC_STORAGE_CLASS_INFO int axiscGetAttributeAsIntCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__boolean axiscGetAttributeAsBooleanCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned int axiscGetAttributeAsUnsignedIntCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO short axiscGetAttributeAsShortCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned short axiscGetAttributeAsUnsignedShortCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO char axiscGetAttributeAsByteCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned char axiscGetAttributeAsUnsignedByteCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO long axiscGetAttributeAsLongCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO long axiscGetAttributeAsIntegerCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned long axiscGetAttributeAsUnsignedLongCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO float axiscGetAttributeAsFloatCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO double axiscGetAttributeAsDoubleCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO double axiscGetAttributeAsDecimalCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetAttributeAsStringCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetAttributeAsAnyURICallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetAttributeAsQNameCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__hexBinary axiscGetAttributeAsHexBinaryCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__base64Binary axiscGetAttributeAsBase64BinaryCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetAttributeAsDateTimeCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetAttributeAsDateCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetAttributeAsTimeCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO long axiscGetAttributeAsDurationCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized value of complex types */
AXISC_STORAGE_CLASS_INFO void * axiscGetCmplxObjectCallBase(AXISCHANDLE callBase, void * pDZFunct, 
	void * pCreFunct, void * pDelFunct, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized Array of complex types */
AXISC_STORAGE_CLASS_INFO Axisc_Array axiscGetCmplxArrayCallBase(AXISCHANDLE callBase, void * pDZFunct, 
	void * pCreFunct, void * pDelFunct, void * pSizeFunct, 
	const AxiscChar * pName, const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized Array of basic types */
AXISC_STORAGE_CLASS_INFO Axisc_Array axiscGetBasicArrayCallBase(AXISCHANDLE callBase, AXISC_XSDTYPE nType, 
	const AxiscChar * pName, const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO int axiscCheckMessageCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO void * axiscCheckFaultCallBase(AXISCHANDLE callBase, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Minimal error check */
AXISC_STORAGE_CLASS_INFO int axiscGetStatusCallBase(AXISCHANDLE callBase);
AXISC_STORAGE_CLASS_INFO AxiscAnyType * axiscGetAnyObjectCallBase(AXISCHANDLE callBase);
AXISC_STORAGE_CLASS_INFO int axiscAddAnyObjectCallBase(AXISCHANDLE callBase, AxiscAnyType * pAnyObject);
AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetNamespacePrefixCallBase(AXISCHANDLE callBase, const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateHeaderBlockCallBase(AXISCHANDLE callBase, AxiscChar * pachLocalName, 
	AxiscChar * pachUri, AxiscChar * pachPrefix);

/* A separate call class object should be used by each thread */
AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateCall();
AXISC_STORAGE_CLASS_INFO void axiscDestroyCall(AXISCHANDLE call);
AXISC_STORAGE_CLASS_INFO void axiscSetSOAPVersionCall(AXISCHANDLE call, AXISC_SOAP_VERSION version);
AXISC_STORAGE_CLASS_INFO int axiscSetTransportPropertyCall(AXISCHANDLE call, AXISC_TRANSPORT_INFORMATION_TYPE type, 
	const char * value);
AXISC_STORAGE_CLASS_INFO int axiscSetHandlerPropertyCall(AXISCHANDLE call, AxiscChar * name, 
	void * value, int len);
AXISC_STORAGE_CLASS_INFO int axiscSetProtocolCall(AXISCHANDLE call, AXISC_PROTOCOL_TYPE protocol);
AXISC_STORAGE_CLASS_INFO AXISC_PROTOCOL_TYPE axiscGetProtocol(AXISCHANDLE call);
AXISC_STORAGE_CLASS_INFO int axiscUnInitializeCall(AXISCHANDLE call);
AXISC_STORAGE_CLASS_INFO int axiscInitializeCall(AXISCHANDLE call, AXISC_PROVIDERTYPE nStyle);
AXISC_STORAGE_CLASS_INFO int axiscInvokeCall(AXISCHANDLE call);

/* Method for adding complex parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddCmplxParameterCall(AXISCHANDLE call, void * pObject, 
	void * pSZFunct, void * pDelFunct, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method for adding complex type array parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddCmplxArrayParameterCall(AXISCHANDLE call, Axisc_Array * pArray, 
	void * pSZFunct, void * pDelFunct, void * pSizeFunct, 
	const AxiscChar * pName, const AxiscChar * pNamespace);

/* Method for adding basic type array parameters */
AXISC_STORAGE_CLASS_INFO void axiscAddBasicArrayParameterCall(AXISCHANDLE call, Axisc_Array * pArray, 
	AXISC_XSDTYPE nType, const AxiscChar * pName);

/* Method for adding parameters of basic types */
AXISC_STORAGE_CLASS_INFO void axiscAddParameterCall(AXISCHANDLE call, void * pValue, 
	const char * pchName, AXISC_XSDTYPE nType);

/* Method that set the remote method name */
AXISC_STORAGE_CLASS_INFO void axiscSetOperationCall(AXISCHANDLE call, const char * pchOperation, 
	const char * pchNamespace);
AXISC_STORAGE_CLASS_INFO int axiscSetEndpointURICall(AXISCHANDLE call, const char * pchEndpointURI);
AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateHeaderBlockCall(AXISCHANDLE call, AxiscChar * pachLocalName, 
	AxiscChar * pachUri, AxiscChar * pachPrefix);

/* Methods used by stubs to get a deserialized value of XML element
     * as basic types
     */
AXISC_STORAGE_CLASS_INFO int axiscGetElementAsIntCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO int axiscGetFaultDetailCall(AXISCHANDLE call, char * * ppcDetail);
AXISC_STORAGE_CLASS_INFO xsdc__boolean axiscGetElementAsBooleanCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned int axiscGetElementAsUnsignedIntCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO short axiscGetElementAsShortCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned short axiscGetElementAsUnsignedShortCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO char axiscGetElementAsByteCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned char axiscGetElementAsUnsignedByteCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__long axiscGetElementAsLongCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO long axiscGetElementAsIntegerCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned long axiscGetElementAsUnsignedLongCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO float axiscGetElementAsFloatCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO double axiscGetElementAsDoubleCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO double axiscGetElementAsDecimalCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetElementAsStringCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetElementAsAnyURICall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetElementAsQNameCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__hexBinary axiscGetElementAsHexBinaryCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__base64Binary axiscGetElementAsBase64BinaryCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetElementAsDateTimeCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetElementAsDateCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetElementAsTimeCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO long axiscGetElementAsDurationCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Methods used by stubs to get a deserialized value of a XML attribute
     * as basic types
     */
AXISC_STORAGE_CLASS_INFO int axiscGetAttributeAsIntCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__boolean axiscGetAttributeAsBooleanCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned int axiscGetAttributeAsUnsignedIntCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO short axiscGetAttributeAsShortCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned short axiscGetAttributeAsUnsignedShortCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO char axiscGetAttributeAsByteCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned char axiscGetAttributeAsUnsignedByteCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO long axiscGetAttributeAsLongCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO long axiscGetAttributeAsIntegerCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO unsigned long axiscGetAttributeAsUnsignedLongCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO float axiscGetAttributeAsFloatCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO double axiscGetAttributeAsDoubleCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO double axiscGetAttributeAsDecimalCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetAttributeAsStringCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetAttributeAsAnyURICall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO AxiscChar * axiscGetAttributeAsQNameCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__hexBinary axiscGetAttributeAsHexBinaryCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO xsdc__base64Binary axiscGetAttributeAsBase64BinaryCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetAttributeAsDateTimeCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetAttributeAsDateCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO struct tm axiscGetAttributeAsTimeCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO long axiscGetAttributeAsDurationCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized value of complex types */
AXISC_STORAGE_CLASS_INFO void * axiscGetCmplxObjectCall(AXISCHANDLE call, void * pDZFunct, 
	void * pCreFunct, void * pDelFunct, const AxiscChar * pName, 
	const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized Array of complex types */
AXISC_STORAGE_CLASS_INFO Axisc_Array axiscGetCmplxArrayCall(AXISCHANDLE call, void * pDZFunct, 
	void * pCreFunct, void * pDelFunct, void * pSizeFunct, 
	const AxiscChar * pName, const AxiscChar * pNamespace);

/* Method used by stubs to get a deserialized Array of basic types */
AXISC_STORAGE_CLASS_INFO Axisc_Array axiscGetBasicArrayCall(AXISCHANDLE call, AXISC_XSDTYPE nType, 
	const AxiscChar * pName, const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO int axiscCheckMessageCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO void * axiscCheckFaultCall(AXISCHANDLE call, const AxiscChar * pName, 
	const AxiscChar * pNamespace);
AXISC_STORAGE_CLASS_INFO int axiscGetStatusCall(AXISCHANDLE call);

/**
    * Set proxy server and port for transport.
    *
    * @param pcProxyHost Host name of proxy server
    * @param uiProxyPort Port of proxy server
    */
AXISC_STORAGE_CLASS_INFO void axiscSetProxyCall(AXISCHANDLE call, const char * pcProxyHost, 
	unsigned int uiProxyPort);
AXISC_STORAGE_CLASS_INFO AxiscAnyType * axiscGetAnyObjectCall(AXISCHANDLE call);
AXISC_STORAGE_CLASS_INFO int axiscAddAnyObjectCall(AXISCHANDLE call, AxiscAnyType * pAnyObject);
AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetNamespacePrefixCall(AXISCHANDLE call, const AxiscChar * pNamespace);


/*
       Following are pointers to relevant objects of the ClientAxisEngine
       instance. So they do not belong to this object and are not created
       or deleted
     */
/*
       Transport object
     */
/* Minimal error check */
/**
    * Proxy server name.
    */
/**
    * Proxy server port.
    */
/**
    * Use Proxy or not?
    */
/**
    * If this object calls initialize_module, this will be set to true.
    * Helps keep track of whether to call uninitialize_module in destructor.
    * It is possible that initialize_module could have been called already.
    */
/**
    * To track if the initialize was called/matched with an uninitialize
    */
// Samisa m_pchSessionID was misssing and there was a compile error due to this


#endif // CALL_INCLUDED
